//physics simulation. The moons have mass and attract each other.
//Only the first moon is fixed, the others move by newton's laws
Moon[] moons = new Moon[3];

class Moon {
      final static float G = 5; //constant of gravity
      float x = width / 2;      //horizontal position
      float y = random(height); //vertical position
      float r = random(2,6);    //radius
      float m = 4*r*r*r / 3;    //mass of a sphere
      float vx = random(-3,3);  //horizontal velocity;
      float vy = 0;             //vertical velocity
      void show(){
           fill(255,255,0);
           ellipse(x,y,2*r,2*r);
      }
      void newton(Moon[] others){
           float Fx = 0;
           float Fy = 0;
           for (int i=0; i<others.length; i++){
                if (this != others[i]){                                   //dont attract self
                    float d = dist(x, y, others[i].x, others[i].y);       //distance
                    float theta = atan2(others[i].y - y,others[i].x - x); //distance vector
                    float F = G * m * others[i].m / (d*d);                //gravitation law
                    Fx += F * cos(theta);                                 //force vector x
                    Fy += F * sin(theta);                                 //force vector y
                }
           }
           float ax = Fx / m;      //acceleration
           float ay = Fy / m;      //idem y
           vx += ax;               //velocity integrates acceleration
           vy += ay;               //idem y
           x += vx;                //position integrates velocity
           y += vy;                //idem y
      }
}

void setup(){
     size(800,600);
     background(0);
     moons[0] = new Moon(); moons[0].r = 10; //the big planet
     moons[1] = new Moon();                  //a random-size object
     moons[2] = new Moon();                  //idem
}
void draw(){
     moons[1].newton(moons);                  
     moons[2].newton(moons); 
     for (int i = 0; i<moons.length; i++)
          moons[i].show();
}
     
